local BS = AceLibrary("Babble-Spell-2.2")

--Downranking exceptions: Flame Shock, Frost Shock. Rest is normal.
--No downranking penalty on: Lightning Shield, Searing Totem, Fire Nova Totem, Magma Totem, Healing Stream Totem and Earth Shield

function DrDamage:ShamanData()

	local ShamanTable = {

		spellInfo = {
			[BS["Lightning Shield"]] = {
							[0] = { School = "Nature", Instant = true, bonusFactor = 0.805, sHits = 3, NoDPS = true, NoDoom = true, },
							[1] = { 13, 13, spellLevel = 8, },
							[2] = { 29, 29, spellLevel = 16, },
							[3] = { 51, 80, spellLevel = 24, },
							[4] = { 80, 80, spellLevel = 32, },
							[5] = { 114, 114, spellLevel = 40, },
							[6] = { 154, 154, spellLevel = 48, },
							[7] = { 198, 198, spellLevel = 56, },
							[8] = { 232, 232, spellLevel = 63, },
							[9] = { 287, 287, spellLevel = 70, },
			},	
			[BS["Lightning Bolt"]] = {
							[0] = { School = { "Nature", "Nuke" }, canCrit = true, castTime = 3, CastMod = 0.2, Downrank = 2, BaseIncrease = true, },
							[1] = { 13, 15, 2, 2, spellLevel = 1, maxLevel = 7, castTime = 1.5, Downrank = 1 },
							[2] = { 26, 30, 2, 3, spellLevel = 8, maxLevel = 13, castTime = 2, },
							[3] = { 45, 53, 3, 4, spellLevel = 14, maxLevel = 19, castTime = 2.5, },
							[4] = { 83, 95, 5, 5, spellLevel = 20, maxLevel = 25, },
							[5] = { 125, 143, 6, 6, spellLevel = 26, maxLevel = 31, },
							[6] = { 172, 194, 7, 8, spellLevel = 32, maxLevel = 37, },
							[7] = { 227, 255, 8, 9, spellLevel = 38, maxLevel = 43, },
							[8] = { 282, 316, 9, 10, spellLevel = 44, maxLevel = 49, },
							[9] = { 347, 389, 10, 11, spellLevel = 50, maxLevel = 55, },
							[10] = { 419, 467, 12, 12, spellLevel = 56, maxLevel = 61, }, 
							[11] = { 495, 565, 10, 12, spellLevel = 62, maxLevel = 66, Downrank = 3 }, 
							[12] = { 563, 643, 8, 9, spellLevel = 67, maxLevel = 70, },
			},
			[BS["Chain Lightning"]] = {
							[0] = { School = { "Nature", "Nuke" }, canCrit = true, castTime = 2.5, CastMod = 0.2, Cooldown = 6, chainFactor = 0.7, BaseIncrease = true, },
							[1] = { 191, 217, 9, 10, spellLevel = 32, maxLevel = 39, },
							[2] = { 277, 311, 11, 12, spellLevel = 40, maxLevel = 47, },
							[3] = { 378, 424, 13, 14, spellLevel = 48, maxLevel = 55, },
							[4] = { 493, 551, 15, 16, spellLevel = 56, maxLevel = 62, },
							[5] = { 603, 687, 17, 18, spellLevel = 63, maxLevel = 69, },
							[6] = { 734, 838, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Earth Shock"]] = {
							[0] = { School = { "Nature", "Shock" }, Instant = true, canCrit = true, Cooldown = 6, sFactor = 0.90, Downrank = -4, BaseIncrease = true, },
							[1] = { 17, 19, 2, 3, spellLevel = 4, maxLevel = 7, Downrank = 4, },
							[2] = { 32, 34, 3, 4, spellLevel = 8, maxLevel = 13, Downrank = 2, },
							[3] = { 60, 64, 5, 5, spellLevel = 14, maxLevel = 23, Downrank = -2, },
							[4] = { 119, 127, 7, 7, spellLevel = 24, maxLevel = 35, },
							[5] = { 225, 239, 10, 10, spellLevel = 36, maxLevel = 47, },
							[6] = { 359, 381, 13, 13, spellLevel = 48, maxLevel = 59, }, 
							[7] = { 517, 545, 15, 16, spellLevel = 60, maxLevel = 69, },
							[8] = { 658, 692, 3, 4, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Flame Shock"]] = {
							[0] = { School = { "Fire", "Shock" }, Instant = true, canCrit = true, Cooldown = 6, eDuration = 12, sTicks = 3, sFactor = 0.5, Downrank = -3, BaseIncrease = true, },
							[1] = { 21, 21, 4, 4, hybridDotDmg = 28, spellLevel = 10, maxLevel = 17, Downrank = 1 },
							[2] = { 45, 45, 6, 6, hybridDotDmg = 49, spellLevel = 18, maxLevel = 27, Downrank = -1 },
							[3] = { 86, 86, 8, 9, hybridDotDmg = 96, spellLevel = 28, maxLevel = 39, },
							[4] = { 152, 152, 10, 11, hybridDotDmg = 168, spellLevel = 40, maxLevel = 51, },
							[5] = { 230, 230, 14, 15, hybridDotDmg = 256, spellLevel = 52, maxLevel = 59, },
							[6] = { 309, 309, 24, 25, hybridDotDmg = 344, spellLevel = 60, maxLevel = 69, },
							[7] = { 377, 377, 0, 0, hybridDotDmg = 420, spellLevel = 70, maxLevel = 70, },
							--NOTE: Downrank -3 -> exception
			},
			[BS["Frost Shock"]] = {
							[0] = { School = { "Frost", "Shock" }, Instant = true, canCrit = true, Cooldown = 6, sFactor = 0.90, Downrank = -3, BaseIncrease = true, },
							[1] = { 89, 95, 6, 6, spellLevel = 20, maxLevel = 33, Downrank = -5 },
							[2] = { 206, 220, 9, 10, spellLevel = 34, maxLevel = 45, },
							[3] = { 333, 353, 12, 13, spellLevel = 46, maxLevel = 57, },
							[4] = { 486, 514, 15, 15, spellLevel = 58, maxLevel = 67, },
							[5] = { 640, 676, 7, 7, spellLevel = 68, maxLevel = 70, },
							--NOTE: Downrank: -3 -> exception
			},		
			[BS["Searing Totem"]] = {
							[0] = { School = { "Fire", "OffensiveTotem" }, Instant = true, sHits = true, eDot = true, canCrit = true, },
							[1] = { 9, 11, spellLevel = 10, eDuration = 30, sHits = 12, },
							[2] = { 13, 17, spellLevel = 20, eDuration = 35, sHits = 14, },
							[3] = { 19, 25, spellLevel = 30, eDuration = 40, sHits = 16, },
							[4] = { 26, 34, spellLevel = 40, eDuration = 45, sHits = 18, },
							[5] = { 33, 45, spellLevel = 50, eDuration = 50, sHits = 20, },
							[6] = { 40, 54, spellLevel = 60, eDuration = 55, sHits = 22, },
							[7] = { 50, 66, spellLevel = 69, eDuration = 60, sHits = 24, }, 
			},
			[BS["Fire Nova Totem"]] = {
							[0] = { School = { "Fire", "OffensiveTotem" }, Instant = true, canCrit = true, sFactor = 1/2, Cooldown = 15, NextRank = 10, BaseIncrease = true, },
							[1] = { 48, 56, 5, 6, spellLevel = 12, },
							[2] = { 102, 116, 8, 8, spellLevel = 22, },
							[3] = { 184, 208, 11, 11, spellLevel = 32, },
							[4] = { 281, 317, 14, 14, spellLevel = 42, },
							[5] = { 396, 442, 17, 17, spellLevel = 52, },
							[6] = { 518, 578, 19, 20, spellLevel = 61, },
							[7] = { 654, 730, 0, 0, spellLevel = 70, },
			},
			[BS["Magma Totem"]] = {
							[0] = { School = { "Fire", "OffensiveTotem" }, Instant = true, canCrit = true, eDot = true, eDuration = 20, sHits = 10, sFactor = 1/2, },
							[1] = { 22, 22, spellLevel = 26, },
							[2] = { 37, 37, spellLevel = 36, },
							[3] = { 54, 54, spellLevel = 46, },
							[4] = { 75, 75, spellLevel = 56, },
							[5] = { 97, 97, spellLevel = 67, },
			},		
			[BS["Lesser Healing Wave"]] = {
							[0] = { School = { "Nature", "Healing", }, canCrit = true, BaseIncrease = true, Downrank = -2, },
							[1] = { 162, 186, 8, 9, spellLevel = 20, maxLevel = 27, },
							[2] = { 247, 281, 10, 11, spellLevel = 28, maxLevel = 35, },
							[3] = { 337, 381, 12, 13, spellLevel = 36, maxLevel = 43, },
							[4] = { 458, 514, 15, 15, spellLevel = 44, maxLevel = 51, },
							[5] = { 631, 705, 18, 18, spellLevel = 52, maxLevel = 59, },
							[6] = { 832, 928, 21, 21, spellLevel = 60, maxLevel = 65, Downrank = 0 },
							[7] = { 1039, 1185, 12, 13, spellLevel = 66, maxLevel = 70, },
			},
			[BS["Healing Wave"]] = {
							[0] = { School = { "Nature", "Healing", }, canCrit = true, castTime = 3, CastMod = 0.1, BaseIncrease = true, Downrank = -2, },
							[1] = { 34, 44, 2, 3, spellLevel = 1, maxLevel = 5, castTime = 1.5, Downrank = -1 },
							[2] = { 64, 78, 5, 5, spellLevel = 6, maxLevel = 11, castTime = 2.0, Downrank = 0, },
							[3] = { 129, 155, 7, 8, spellLevel = 12, maxLevel = 17, castTime = 2.5, Downrank = 0, },
							[4] = { 268, 316, 11, 12, spellLevel = 18, maxLevel = 23, Downrank = 0, },
							[5] = { 376, 440, 13, 14, spellLevel = 24, maxLevel = 31, },
							[6] = { 536, 622, 16, 17, spellLevel = 32, maxLevel = 39, },
							[7] = { 740, 854, 19, 20, spellLevel = 40, maxLevel = 47, },
							[8] = { 1017, 1167, 23, 24, spellLevel = 48, maxLevel = 55, },
							[9] = { 1367, 1561, 27, 28, spellLevel = 56, maxLevel = 61, },
							[10] = { 1620, 1850, 27, 28, spellLevel = 60, maxLevel = 62, Downrank = 3 },
							[11] = { 1725, 1969, 31, 32, spellLevel = 63, maxLevel = 69, Downrank = -1 },
							[12] = { 2134, 2436, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Chain Heal"]] = {
							[0] = { School = { "Nature", "Healing", }, canCrit = true, castTime = 2.5, chainFactor = 0.5, BaseIncrease = true, },
							[1] = { 320, 368, 12, 13, spellLevel = 40, maxLevel = 45, },
							[2] = { 405, 465, 14, 14, spellLevel = 46, maxLevel = 53, Downrank = -2, },
							[3] = { 551, 629, 16, 17, spellLevel = 54, maxLevel = 60, Downrank = -1  },
							[4] = { 605, 691, 19, 19, spellLevel = 61, maxLevel = 67, Downrank = -1, },
							[5] = { 826, 942, 7, 8, spellLevel = 68, maxLevel = 70, },
			},
			[BS["Healing Stream Totem"]] = {
							[0] = { School = { "Nature", "Healing", }, Instant = true, eDot = true, eDuration = 60, sHits = 30, sFactor = 1/3, },
							[1] = { 6, 6, spellLevel = 20, }, 
							[2] = { 8, 8, spellLevel = 30, },
							[3] = { 10, 10, spellLevel = 40, },
							[4] = { 12, 12, spellLevel = 50, },
							[5] = { 14, 14, spellLevel = 60, },
							[6] = { 18, 18, spellLevel = 69, },
			},
			[BS["Earth Shield"]] = {
							[0] = { School = { "Nature", "Healing", }, Instant = true, canCrit = true, sHits = 10, bonusFactor = 10/3.5, NoDPS = true, NoDoom = true, NoDebuffs = true },
							[1] = { 150, 150, spellLevel = 50, },
							[2] = { 205, 205, spellLevel = 60, },
							[3] = { 270, 270, spellLevel = 70, },
			},
			[BS["Gift of the Naaru"]] = {
							[0] = { School = { "Holy", "Healing" }, Cooldown = 180, castTime = 1.5, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, },
							["None"] = { 35, 35, 1050, 1050, spellLevel = 0, maxLevel = 70, },
			},			
		},
		talentInfo = { 
			["Concussion"] = { Effect = 0.01, Spells = { "Nuke", "Shock" }, },
			["Call of Flame"] = { Effect = 0.05, Spells = { "OffensiveTotem" }, },
			["Call of Thunder"] = { Effect = { 1, 2, 3, 4, 6 } , Spells = { "Nuke" }, ModType = "Crit", },
			["Elemental Focus"] = { Effect = 1, Spells = { "Nuke", "Shock", }, ModType = "FreeCrit" },
			["Lightning Mastery"] = { Effect = 1, Spells = { "Nuke" }, ModType = "CastTime", },
			["Elemental Fury"] = { Effect = 0.5, Spells = { "Nuke", "Shock", "OffensiveTotem" }, ModType="CritMultiplier", },
			["Elemental Precision"] = { Effect = 2, Spells = { "Lightning Shield", "Nuke", "Shock", "OffensiveTotem", }, ModType = "Hit", },
			["Nature's Guidance"] = { Effect = 1, Spells = { "All" }, ModType = "Hit", },
			["Improved Lightning Shield"] = { Effect = 0.05, Spells = { "Lightning Shield" }, },
			["Tidal Mastery"] = { Effect = 1, Spells = { "Healing", "Nuke" }, ModType = "Crit", },
			["Purification"] = { Effect = 0.02, Spells = { "Healing"  }, Effect2 = 1, Spells2 = { "Earth Shield" }, ModType = "BuffTalentRank", },
			["Improved Chain Heal"] = { Effect = 0.10, Spells = { "Chain Heal"  }, },
			["Improved Healing Wave"] = { Effect = 1, Spells = { "Healing Wave"  }, ModType = "CastTime" },
			["Restorative Totems"] = { Effect = 0.05, Spells = { "Healing Stream Totem" }, },
			["Reverberation"] = { Effect = 0.2, Spells = { "Shock" }, ModType = "Cooldown" },
		},

	}
	
	return ShamanTable["spellInfo"], ShamanTable["talentInfo"]
end